; data_demo_gen
; Diese Routine dient der Erstellung von beliebigen
; Eingangdaten mit konstantem Inhalt um RBM zu testen.
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Einlesen des Originalpfades
inp_pfd='E:\Modelldaten\namibia_gesamt_1km_UTM33south_seamask.dat'

ENVI_OPEN_FILE, inp_pfd, r_fid = fid, /no_realize
ENVI_FILE_QUERY, fid, ns=ns, nl=nl
map_info=ENVI_GET_MAP_INFO(fid=fid)
ENVI_FILE_MNG, id=fid, /remove
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Zeitliche Eingrenzung
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
modelling_start=	[1,2001]
modelling_end=		[36,2001]
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; GUI zum Abfragen der zu erzugenden Demo-Dateien
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
list=['MOD09','CLOUD','TEMPERATURE','WATERVAPOR','EMISSITIVITY','SOIL','DGM']
base=WIDGET_AUTO_BASE(title='RBM - DEMO DATA GENERATOR')
  w1=WIDGET_BASE(base, /row, /frame)
	e1=WIDGET_SLIST(w1, uvalue='param', list=list, $
	   prompt='Please select DEMO Parameter',$
	   default=1, /auto)
  w3=WIDGET_BASE(base, row=2, /frame)
   	p5 = WIDGET_PARAM(w3, dt=2, xsize=2, $
         default=modelling_start(0), uvalue='start_ts', $
         prompt='Modelling Start: Timestep', /auto)
   	p6 = WIDGET_PARAM(w3, dt=2, xsize=4, $
         default=modelling_start(1), uvalue='start_year', $
         prompt='Year', /auto)
   	p7 = WIDGET_PARAM(w3, dt=2, xsize=2, $
         default=modelling_end(0), uvalue='end_ts', $
         prompt='Modelling End: Timestep', /auto)
   	p8 = WIDGET_PARAM(w3, dt=2, xsize=4, $
         default=modelling_end(1), uvalue='end_year', $
         prompt='Year', /auto)
  w4=WIDGET_BASE(base, row=2, /frame)
   	p5 = WIDGET_PARAM(w4, dt=2, xsize=4, $
         uvalue='wert', $
         prompt='DEMO Value for Parameter', /auto)
  w2=WIDGET_BASE(base, row=2, /frame)
    p1 = WIDGET_OUTF(w2, uvalue='outf', /directory, /auto)

result=AUTO_WID_MNG(base)
if (result.accept eq 0) then RETALL  ;exit by cancel-button
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Auslesen der ersten GUI
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
HOME_PFD=(result.outf)
wert=(result.wert)
parameter=(result.param)
;--------------------------------------
modelling_start(0)=(result.start_ts)
modelling_start(1)=(result.start_year)
modelling_end(0)=(result.end_ts)
modelling_end(1)=(result.end_year)
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Berechung der Modelllaufzeit
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Ermittlung der Modelljahre
model_years=modelling_end(1) - modelling_start(1)+1
y=0
model_time=INTARR(model_years,2)
for t=0,model_years-1 do begin
	model_time(t,0)=modelling_start(1)+y
	y=y+1
endfor
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Zuordnung der Demodateninfo
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; DATATYPE
; ---------------------------------------------------------
CASE parameter OF
0 : dt=2
1 : dt=1
2 : dt=4
3 : dt=4
4 : dt=4
5 : dt=4
6 : dt=2
ENDCASE
; ---------------------------------------------------------
; Anzahl der Bnder
; ---------------------------------------------------------
CASE parameter OF
0 : nb=7
1 : nb=1
2 : nb=1
3 : nb=1
4 : nb=1
5 : nb=1
6 : nb=1
ENDCASE
; ---------------------------------------------------------
; BAND Names
; ---------------------------------------------------------
CASE parameter OF
0 : bnames=['DEMO B1','DEMO B2','DEMO B3','DEMO B4','DEMO B5','DEMO B6','DEMO B7']
1 : bnames=['DEMO_% Cloud']
2 : bnames=['DEMO_% Temp']
3 : bnames=['DEMO_% WV']
4 : bnames=['DEMO_% EMS']
5 : bnames=['DEMO_% SOIL']
6 : bnames=['DEMO_% DGM']
ENDCASE
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Erzeugen der Demodateien
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++





; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Ende der Routine DATA_DEMO_GENERATOR.pro
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
END