; RBM_Analyse
; Dieses Program dient zur Analyse der Ergebnisse des RBMs.
; Fr Zeitreihenanalysen werden die einzelnen Jahresdaten
; zu Zeitreihenstzen zusammengefasst.
; ---------------------------------------------------------
; Sub ROUTINE PRO STATISTIC
; ---------------------------------------------------------
PRO STATISTIC, data, sum, mean_ts, median_ts, stdv_m, max_ts, min_ts
  data=FLOAT(data)
  sum = TOTAL(data)
  mean_ts = MEAN(data)
  median_ts = MEDIAN(data)
  stdv_m = STDDEV(data)
  ;max_ts = MAX(data, MIN=min_ts)
END

; ---------------------------------------------------------
; BEGINN des Hauptprogramms
; ---------------------------------------------------------
START:
title='Please select first data file and one band'
ENVI_SELECT, fid=fid,dims=dims,pos=pos, title=title
IF (fid[0] eq -1) THEN retall
IF n_elements(pos) gt 1 THEN BEGIN
ENVI_FILE_MNG, id=fid, /remove ;,/delete
GOTO,START
ENDIF
o_title = 'Please select output file name'
out_name=ENVI_PICKFILE(title=o_title)
IF out_name eq '' THEN retall
; ---------------------------------------------------------
; Einlesen der ersten Datei um allg. Dateiinfos zu erhalten
; ---------------------------------------------------------
map_info = ENVI_GET_MAP_INFO(fid=fid)
ENVI_FILE_QUERY, fid, ns=ns, nl=nl, nb=nb, $
  fname=fname, data_type=dt
ENVI_FILE_MNG, id=fid, /remove ;,/delete
; ---------------------------------------------------------
; Suchen der brigen Dateien dieses Verzeichnisses
; ---------------------------------------------------------
in_pfad = STRMID(fname, 0,(STRPOS(fname, '\', /REVERSE_SEARCH))+1)
datsuch = STRMID(fname,(STRPOS(fname,'\',/REVERSE_SEARCH))+1)
such_string1 = STRMID(datsuch,0,(STRPOS(datsuch,'_',/REVERSE_SEARCH)))
such_string2 = '*.data'
such_all = in_pfad + such_string1 + such_string2
; ---------------------------------------------------------
data_names = findfile(such_all, count=count)
if count lt 1 then return
;data_names = SORT(data_names)
; ---------------------------------------------------------
nb=count
if (dt eq 1) then data=BYTARR(ns,nl,nb)
if (dt eq 2) then data=INTARR(ns,nl,nb)
if (dt eq 3) then data=LONARR(ns,nl,nb)
if (dt eq 4) then data=FLTARR(ns,nl,nb)
if (dt eq 5) then data=DBLARR(ns,nl,nb)
if (dt eq 6) then data=DCOMPLEXARR(ns,nl,nb)
if (dt eq 14) then data=LONARR(ns,nl,nb)
if (dt eq 12) then data=UINTARR(ns,nl,nb)
if (dt eq 13) then data=ULONARR(ns,nl,nb)
if (dt eq 15) then data=ULON64ARR(ns,nl,nb)
bnames=STRARR(count)
; ---------------------------------------------------------
; Einlesen der einzellnen Dateien
; ---------------------------------------------------------
FOR i=0, count-1 DO BEGIN
ENVI_OPEN_FILE, data_names(i), r_fid=fid, /NO_REALIZE
if (fid eq -1) then return
ENVI_FILE_QUERY,fid, bnames=band
bnames(i) = band(pos)
data(*,*,i)=ENVI_GET_DATA(fid=fid, dims=dims, pos=pos)
ENVI_FILE_MNG, id=fid, /remove
ENDFOR
; ---------------------------------------------------------
; Ausgabe der  Datei
; ---------------------------------------------------------
OPENW, 10, out_name
WRITEU,10, data
CLOSE,10
data_name = STRMID(data_names,(STRPOS(data_names(0),'\',/REVERSE_SEARCH))+1)
data_name = STRMID(data_name,0,(STRPOS(data_name(0),'.',/REVERSE_SEARCH)))
bname = data_name + '.' + bnames
ENVI_SETUP_HEAD, fname=out_name, $
  ns=ns, nl=nl, nb=count, bnames=bname, $
  interleave=0, data_type=dt, $
  offset=0, file_type=0, $
  map_info=map_info, /write, r_fid=oid, /open
;ENVI_FILE_MNG, id=oid, /remove ;,/delete
; ---------------------------------------------------------
; Erfassen der Statistik: Summe, Mean, Stdv, Median, Stdv
; ---------------------------------------------------------
;stat_out=FLTARR(ns,nl,6)
;;FOR y=0,nl-1 DO BEGIN
;;FOR x=0,ns-1 DO BEGIN
;  ;STATISTIC, data, sum, mean_ts, median_ts, stdv_m, $
;  ;			max_ts, min_ts
;  ;stat_out(x,y,0)=sum
;  ;stat_out(x,y,1)=mean_ts
;  ;stat_out(x,y,2)=median_ts
;  ;stat_out(x,y,3)=stdv_m
;  ;stat_out(x,y,4)=max_ts
;  ;stat_out(x,y,5)=min_ts
; ; print, x,y
;;ENDFOR
;;ENDFOR
;print, 'max_beginn'
;stat_out(*,*,4) = FLOAT(MAX(data(*,*,*), MIN=min_ts, /NAN))
;stat_out(*,*,5) = min_ts
;; ---------------------------------------------------------
;; Ausgabe der Statistik
;; ---------------------------------------------------------
;stat_out_name = STRMID(out_name,0,(STRPOS(out_name,'.',/REVERSE_SEARCH))) + '_stats.data'
;GET_LUN, U
;OPENW, U, stat_out_name
;WRITEU, U, stat_out
;CLOSE, U
;FREE_LUN, U
;bdnames = STRARR(6)
;bdnames(0) = 'sum of ' + bnames(0)
;bdnames(1) = 'mean of' + bnames(0)
;bdnames(2) = 'median of ' + bnames(0)
;bdnames(3) = 'STDV of ' + bnames(0)
;bdnames(4) = 'MAX of ' + bnames(0)
;bdnames(5) = 'MIN of ' + bnames(0)
;ENVI_SETUP_HEAD, fname=stat_out_name, $
;  ns=ns, nl=nl, nb=6, bnames=bdnames, $
;  interleave=0, data_type=4, $
;  offset=0, file_type=0, $
;  map_info=map_info, /write, r_fid=oid
;ENVI_FILE_MNG, id=oid, /remove ;,/delete
; ---------------------------------------------------------
; ENDE der Routine
; ---------------------------------------------------------
END